Index: GTP/trunk/App/Demos/Illum/Ogre/Media/PMDemo/PathMap.hlsl
===================================================================
--- GTP/trunk/App/Demos/Illum/Ogre/Media/PMDemo/PathMap.hlsl	(revision 2186)
+++ GTP/trunk/App/Demos/Illum/Ogre/Media/PMDemo/PathMap.hlsl	(revision 2188)
@@ -1,6 +1,6 @@
 uniform float4x4 WorldViewProj;
-uniform float2 prmAtlasTiles;
-uniform float2 atlasHalfPixel;
+uniform float4 prmAtlasTilesHalfPixel;
 uniform sampler2D filteredAtlasSampler : register(s0);
+uniform float weights[32];
 
 struct vsInputWalk
@@ -30,5 +30,8 @@
 float4	psWalk(vsOutputWalk input) : COLOR
 {
-/*	float3 col = 0;
+	int2 prmAtlasTiles = prmAtlasTilesHalfPixel.xy;
+	float2 atlasHalfPixel = prmAtlasTilesHalfPixel.zw;
+	
+	float3 col = 0;
 	for(int iCluster=0; iCluster<16; iCluster++)
 	{
@@ -56,7 +59,8 @@
 		col += val.xyz * weight.w;
 	}
-*/
-	float ff = (float)prmAtlasTiles.x;
-	return float4( float3(ff,ff,ff) / 128.0/* + col*0.000000001*/, 1);
+	
+	//return col.xxxx *0.00001 + tex2D(filteredAtlasSampler, float2(input.texAtlas.x /32.0f, 1.0 - input.texAtlas.y));
+//return float4(1,0,0,1)+col.xxxx*0.0000000001;
+	return float4(col, 1);
 }
 
Index: GTP/trunk/App/Demos/Illum/Ogre/Media/PMDemo/PRMDemo.material
===================================================================
--- GTP/trunk/App/Demos/Illum/Ogre/Media/PMDemo/PRMDemo.material	(revision 2186)
+++ GTP/trunk/App/Demos/Illum/Ogre/Media/PMDemo/PRMDemo.material	(revision 2188)
@@ -20,11 +20,11 @@
    pass mainpass
    {
-	// IllumTechniques
-	// {
-	//   	RenderTechnique PathMap
-	//   	{
+	IllumTechniques
+	{
+	   	RenderTechnique PathMap
+	  	{
 	    
-	//   	}
-	//}
+	  	}
+	}
    	texture_unit color
    	{
@@ -32,16 +32,5 @@
     }
    }
-   pass pm
-   {
-    vertex_program_ref GTP/PathMap_VS
-    {
-    param_named_auto WorldViewProj worldviewproj_matrix
-    }
-    fragment_program_ref GTP/PathMap_PS 
-  	{
-  	param_named prmAtlasTiles float2 32 1
-  	}
-  	scene_blend one zero
-   }
+   
  }
 }
@@ -117,2 +106,34 @@
   }
 }
+
+
+vertex_program GTP/PathMap_ComputeWeights_VS hlsl
+{
+   source PathMapWeightCompute.hlsl
+   entry_point vsComputeWeights
+   target vs_2_0   
+}
+
+fragment_program GTP/PathMap_ComputeWeights_PS hlsl
+{
+   source PathMapWeightCompute.hlsl
+   entry_point psComputeWeights
+   target ps_2_0   
+}
+
+material GTP/PathMap_ComputeWeights
+{
+	technique
+	{
+		pass
+		{
+			vertex_program_ref GTP/PathMap_ComputeWeights_VS
+			{
+				
+			}
+			fragment_program_ref GTP/PathMap_ComputeWeights_PS
+			{
+			}
+		}
+	}
+}
Index: GTP/trunk/App/Demos/Illum/Ogre/Media/PMDemo/convert.bat
===================================================================
--- GTP/trunk/App/Demos/Illum/Ogre/Media/PMDemo/convert.bat	(revision 2186)
+++ GTP/trunk/App/Demos/Illum/Ogre/Media/PMDemo/convert.bat	(revision 2188)
@@ -1,6 +1,6 @@
 path=%OGRE_PATH%\Samples\Common\bin\Release
-OgreXMLConverter -t  "c:\GameToolsSVN\gtp\trunk\App\Demos\Illum\Ogre\Media\PMDemo\carpetShape.mesh.xml" 
-OgreXMLConverter -t  "c:\GameToolsSVN\gtp\trunk\App\Demos\Illum\Ogre\Media\PMDemo\ironShape.mesh.xml" 
-OgreXMLConverter -t  "c:\GameToolsSVN\gtp\trunk\App\Demos\Illum\Ogre\Media\PMDemo\redwireShape.mesh.xml" 
-OgreXMLConverter -t  "c:\GameToolsSVN\gtp\trunk\App\Demos\Illum\Ogre\Media\PMDemo\greenwireShape.mesh.xml" 
-OgreXMLConverter -t  "c:\GameToolsSVN\gtp\trunk\App\Demos\Illum\Ogre\Media\PMDemo\whitewireShape.mesh.xml" 
+OgreXMLConverter "c:\GameToolsSVN\gtp\trunk\App\Demos\Illum\Ogre\Media\PMDemo\carpetShape.mesh.xml" 
+OgreXMLConverter "c:\GameToolsSVN\gtp\trunk\App\Demos\Illum\Ogre\Media\PMDemo\ironShape.mesh.xml" 
+OgreXMLConverter "c:\GameToolsSVN\gtp\trunk\App\Demos\Illum\Ogre\Media\PMDemo\redwireShape.mesh.xml" 
+OgreXMLConverter "c:\GameToolsSVN\gtp\trunk\App\Demos\Illum\Ogre\Media\PMDemo\greenwireShape.mesh.xml" 
+OgreXMLConverter "c:\GameToolsSVN\gtp\trunk\App\Demos\Illum\Ogre\Media\PMDemo\whitewireShape.mesh.xml" 
Index: GTP/trunk/App/Demos/Illum/Ogre/Media/PMDemo/PathMapWeightCompute.hlsl
===================================================================
--- GTP/trunk/App/Demos/Illum/Ogre/Media/PMDemo/PathMapWeightCompute.hlsl	(revision 2188)
+++ GTP/trunk/App/Demos/Illum/Ogre/Media/PMDemo/PathMapWeightCompute.hlsl	(revision 2188)
@@ -0,0 +1,70 @@
+#define SAMPLECUTDIST2 0.01
+#define WEIGHTCUTOFF 0.01
+
+uniform int nRadionColumns;
+uniform sampler2D radionSampler : register(s0);
+uniform float3 lightPos;
+uniform float3 lightDir;
+
+struct vsInputComputeWeights
+{
+    float4	pos			: POSITION;
+    float2	tex			: TEXCOORD0;
+};
+
+struct vsOutputComputeWeights
+{
+    float4	pos			: POSITION;
+    float2	tex			: TEXCOORD0;
+};
+
+vsOutputComputeWeights
+	vsComputeWeights(vsInputComputeWeights input)
+{
+    vsOutputComputeWeights output = (vsOutputComputeWeights)0;
+    output.pos = input.pos;
+    output.tex = input.tex;
+    return output;
+}
+
+float4
+	psComputeWeights(vsOutputComputeWeights input) : COLOR0
+{
+	float dataColumnWidth = 1.0 / (float)nRadionColumns;
+	int bushIndex = input.tex.x * 4096 + input.tex.y * nRadionColumns * 4096;
+	int werx = bushIndex % nRadionColumns;
+	int wery = bushIndex / nRadionColumns;
+	float3 pos = tex2D(radionSampler, float2((werx + 0.25) * dataColumnWidth, (wery  + 0.5) / 4096.0) ).xyz;
+	float3 dir = tex2D(radionSampler, float2((werx + 0.75) * dataColumnWidth, (wery  + 0.5) / 4096.0) ).xyz;
+	
+	float3 diff = lightPos - pos;
+	float dist2 = dot(diff, diff);
+	if(dist2 < SAMPLECUTDIST2)
+		dist2 = SAMPLECUTDIST2;
+	diff = normalize(diff);
+	float cosa = - dot(lightDir, diff);
+	float cosb = dot(dir, diff);	
+	
+	/*
+	float4 occProjPos = mul(float4(pos, 1), occWorldToProjMatrix);	
+	occProjPos /= occProjPos.w;
+	float2 occTexPos = mul( occProjPos.xyw, occProjToTexMatrix);
+	float visibility = tex2Dproj(depthMapSampler, float4(occTexPos, occProjPos.z - 0.1, 1) );
+
+	float3 lightToPos = pos - lightPos;
+	float actualDepth = length(lightToPos);
+*/
+	float visibility = 1;
+	
+	float ret;
+	if(  visibility < 0.5 || cosa < 0 || cosb < 0)
+		ret = 0.0;
+	else
+		ret = pow(cosa, 9) * cosb / dist2;
+
+	if(ret < 0.000001)
+		ret = 0.0;
+	
+		return 1 + ret * 0.0000000001;
+	return float4(ret, ret, ret, ret);
+}
Index: GTP/trunk/App/Demos/Illum/Ogre/Media/materials/GTPBasic/GTPBasic_PS.hlsl
===================================================================
--- GTP/trunk/App/Demos/Illum/Ogre/Media/materials/GTPBasic/GTPBasic_PS.hlsl	(revision 2181)
+++ GTP/trunk/App/Demos/Illum/Ogre/Media/materials/GTPBasic/GTPBasic_PS.hlsl	(revision 2188)
@@ -33,5 +33,5 @@
 float4 CDepth(CPos_OUT IN) : COLOR
 {
- return IN.CPos.z;	
+ return -IN.CPos.z;	
 }
 
Index: GTP/trunk/App/Demos/Illum/Ogre/Media/materials/GTPBasic/GTPBasic.program
===================================================================
--- GTP/trunk/App/Demos/Illum/Ogre/Media/materials/GTPBasic/GTPBasic.program	(revision 2181)
+++ GTP/trunk/App/Demos/Illum/Ogre/Media/materials/GTPBasic/GTPBasic.program	(revision 2188)
@@ -181,3 +181,10 @@
    target ps_2_0
 }
+
+fragment_program GTP/Basic/SM/ShadowAccum_PS hlsl
+{
+   source GTPShadowAccum.hlsl
+   entry_point ShadowAccum_PS
+   target ps_3_0
+}
    
Index: GTP/trunk/App/Demos/Illum/Ogre/Media/materials/GTPBasic/GTPBasic.material
===================================================================
--- GTP/trunk/App/Demos/Illum/Ogre/Media/materials/GTPBasic/GTPBasic.material	(revision 2181)
+++ GTP/trunk/App/Demos/Illum/Ogre/Media/materials/GTPBasic/GTPBasic.material	(revision 2188)
@@ -74,4 +74,23 @@
   {
    cull_hardware clockwise
+   vertex_program_ref GTP/Basic/CPos_VS
+   {  
+     param_named_auto WorldViewProj worldviewproj_matrix
+     param_named_auto WorldView     worldview_matrix     
+   } 
+   fragment_program_ref GTP/Basic/CDepth_PS
+   {	
+   }   
+  }
+ }
+}
+
+material GTP/Basic/CameraDepthCCW : GTP/Basic/CameraDepthCCW
+{
+ technique
+ {
+  pass
+  {
+   cull_hardware anticlockwise
    vertex_program_ref GTP/Basic/CPos_VS
    {  
@@ -171,2 +190,32 @@
  }
 }
+
+material GTP/Basic/ShadowReciever/ShadowAccum
+{
+ technique
+ {
+   pass
+   {
+    lighting off
+     ambient 1 1 1 1
+	diffuse 1 1 1 1
+	specular 1 1 1 1
+	emissive 0 0 0
+
+     IllumTechniques
+     {
+        RenderTechnique DepthShadowReciever
+		{
+			max_light_count 1
+			vertex_program_name GTP/Basic/LightCPos_VS
+			fragment_program_name GTP/Basic/SM/ShadowAccum_PS
+			set_light_view true
+			set_light_farplane false
+			world_view_proj_param_name WorldViewProj
+			world_param_name World
+			light_viewproj_param_name LightViewProj			
+		}	
+     }
+   }
+ }
+}
Index: GTP/trunk/App/Demos/Illum/Ogre/Media/materials/GTPBasic/GTPShadowAccum.hlsl
===================================================================
--- GTP/trunk/App/Demos/Illum/Ogre/Media/materials/GTPBasic/GTPShadowAccum.hlsl	(revision 2188)
+++ GTP/trunk/App/Demos/Illum/Ogre/Media/materials/GTPBasic/GTPShadowAccum.hlsl	(revision 2188)
@@ -0,0 +1,63 @@
+#define BiasSlope 2.0
+#define LightSize 2.0
+#define Bias 0.05
+#define KernelSize 9.0
+#define LightFov 3.14 * 0.5
+#define ShadowIntensity 0.8
+#define SHADOWMAP_SIZE 512.0f
+
+#define shadowColor float4(0.2,0.2,0.2,1)
+
+uniform sampler2D ShadowMap: register(s0);
+struct LightCPos_OUT
+{
+ float4 VPos : POSITION;
+ float4 LightVPos : TEXCOORD0;
+ float4 LightCPos : TEXCOORD1;
+};
+
+
+float4 ShadowAccum_PS( LightCPos_OUT IN) : COLOR
+{
+	IN.LightCPos.z *= -1;
+	//return float4(IN.LightCPos.xyz,1);
+	
+	float R = max( LightSize, 0.1h );
+	//BiasSlope = max( BiasSlope, 0.1h );
+	float n = R;
+	float mapsize = 2 * n * tan( LightFov / 2.0f );		// size of shadow map in world space
+	float Deltal = mapsize / SHADOWMAP_SIZE;				// size of a lexel edge in world space
+	
+	float3 r = IN.LightCPos;							// shaded point in light's camera space
+	float RR = 1;// R * (r.z - n) / r.z;					// directional set in which the light is seen from the shaded point
+	float step = RR / KernelSize;
+	float RR2 = RR * RR;
+	float2 q = r.xy * n / r.z;							// projection of r onto the shadow plane
+	float2 quv = q / mapsize;			
+	quv = float2( ( 0.5 + quv.x ), ( 0.5 - quv.y ) );	// r in texture coordinates
+	
+	//return (r.z - tex2D( ShadowMap, quv).r);
+	float shadow = 0;
+	for ( int i = 0; i < KernelSize; i++ )
+	{
+		for ( int j = 0; j < KernelSize; j++ )
+		{
+			float2 uvoffset = float2( i - KernelSize / 2.0f, j - KernelSize / 2.0f ) * step /  SHADOWMAP_SIZE;
+			float2 l = q + float2( uvoffset.x, -uvoffset.y ) * mapsize;
+			float cz = tex2D( ShadowMap, quv + uvoffset ).x;
+			float size = (r.z - n)/(r.z - cz) * cz / n;
+
+			float2 lc = (n - cz)/(r.z - cz) * r.xy + size * l.xy;
+			if( cz < r.z - Bias && dot(lc - q, lc - q) < RR2 + BiasSlope )
+				shadow += size * size;
+			
+			//if( cz < r.z - Bias)
+			//  shadow++;
+		}
+	}
+	//shadow /= KernelSize * KernelSize;
+	shadow *= Deltal * Deltal  * step * step/ RR2;
+	//shadow = saturate(shadow);
+	
+	return shadowColor + (1 - shadowColor) * (1 - shadow);
+}
Index: GTP/trunk/App/Demos/Illum/Ogre/src/PRMDemo/include/PRMDemo.h
===================================================================
--- GTP/trunk/App/Demos/Illum/Ogre/src/PRMDemo/include/PRMDemo.h	(revision 2186)
+++ GTP/trunk/App/Demos/Illum/Ogre/src/PRMDemo/include/PRMDemo.h	(revision 2188)
@@ -94,6 +94,72 @@
 		//mSceneMgr = mRoot->createSceneManager("OcclusionCullingSceneManager");
 	}
+
+	/*
+	void createScene(void) /// SHADOWACCUM
+    {
+		//std::string occlusion_cfg("OcclusionCulling.cfg");
+		//mSceneMgr->setWorldGeometry(occlusion_cfg);		
+		//createPostproc();
+
+		OgreIlluminationManager::getSingleton().setMainCamera(mCamera);
+		OgreIlluminationManager::getSingleton().setMainViewport(mWindow->getViewport(0));
+		OgreIlluminationManager::getSingleton().setShadowMapMaterialName("GTP/Basic/CameraDepth");
+		OgreIlluminationManager::getSingleton().setFocusingSM(false);
+	   OgreIlluminationManager::getSingleton().setShadowMapSize(512);
+	   OgreIlluminationManager::getSingleton().setBlurShadowMap(false);
+	   OgreIlluminationManager::getSingleton().setUseLISPSM(false);
+	   OgreIlluminationManager::getSingleton().setAreaLigtRadius(3);
+				
+		Root::getSingleton()._setCurrentSceneManager(mSceneMgr);
+		mCamera->setPosition(0,0,0);
+		//mCamera->setPosition(0,100,0);
+		//mCamera->lookAt(0,-1,0);
+		mCamera->setFOVy(Radian(Degree(80)));
+		mCamera->setNearClipDistance(0.01);
+		mCamera->setFarClipDistance(1000);
+		// Set ambient light
+        mSceneMgr->setAmbientLight(ColourValue(0,0, 0));
+		//mSceneMgr->setSkyBox(true, "Examples/EveningSkyBox", 500);
+		
+		SceneNode* rootNode = mSceneMgr->getRootSceneNode();
+
+		
+		SceneSerializer s(mSceneMgr);
+		DataStreamPtr inputStream; 				
+		//inputStream = ResourceGroupManager::getSingleton().openResource("level.txt");	//towers2.level	
+		//s.parseScript(inputStream, ResourceGroupManager::DEFAULT_RESOURCE_GROUP_NAME);
+
+		Entity* pillar = mSceneMgr->createEntity("pillar", "pillarShape.mesh");
+		SceneNode* pillarNode = rootNode->createChildSceneNode("pillarnode");
+		pillarNode->attachObject(pillar);
+
+			
+		createPlane("p","GTP/Basic/ShadowReciever/ShadowAccum",Vector3(0,-1,0),Vector2(20,20),Vector2(1,1));
+
+		Light* mainLight = mSceneMgr->createLight("MainLight");
+		mainLight->setType(Light::LT_SPOTLIGHT);
+		mainLight->setCastShadows(true);
+        mainLight->setDiffuseColour(ColourValue::White);
+		mainLight->setSpecularColour(ColourValue::White);
+		mainLightNode = rootNode->createChildSceneNode();
+		
+		mainLightNode->setPosition(5,5,5);		
+		mainLight->setPosition(5,5,5);
+		mainLight->setPowerScale(5);
+		mainLight->setDirection(-1,-1, -1);
+		mainLight->setSpotlightOuterAngle(Radian(Degree(90)));
+		mainLight->setAttenuation(20, 1, 0, 0);
+		mainLightNode->attachObject(mainLight); 	
+
+		BillboardSet* bbs = mSceneMgr->createBillboardSet("bb", 1);
+		bbs->setDefaultDimensions(5,5);
+		bbs->createBillboard(Vector3::ZERO, ColourValue::White);
+		bbs->setMaterialName("Flare");
+		mainLightNode->attachObject(bbs);
+		
+		OgreIlluminationManager::getSingleton().initTechniques();
+   }*/
 /*
-	void createScene(void)
+	void createScene(void) ///TOWERS
     {
 		//std::string occlusion_cfg("OcclusionCulling.cfg");
@@ -148,5 +214,5 @@
    }*/
 
-	void createScene(void)
+	void createScene(void) ///PATHMAP Hangar
     {
 		//std::string occlusion_cfg("OcclusionCulling.cfg");
Index: GTP/trunk/App/Demos/Illum/Ogre/src/CausticTest/include/CausticTest.h
===================================================================
--- GTP/trunk/App/Demos/Illum/Ogre/src/CausticTest/include/CausticTest.h	(revision 2179)
+++ GTP/trunk/App/Demos/Illum/Ogre/src/CausticTest/include/CausticTest.h	(revision 2188)
@@ -149,6 +149,6 @@
 	void chooseSceneManager()
 	{
-		//mSceneMgr = mRoot->createSceneManager("OctreeSceneManager");
-		mSceneMgr = mRoot->createSceneManager("OcclusionCullingSceneManager");
+		mSceneMgr = mRoot->createSceneManager("OctreeSceneManager");
+		//mSceneMgr = mRoot->createSceneManager("OcclusionCullingSceneManager");
 	}
 
@@ -181,6 +181,6 @@
 	void createScene(void)
     {
-		std::string occlusion_cfg("OcclusionCulling.cfg");
-		mSceneMgr->setWorldGeometry(occlusion_cfg);
+	//	std::string occlusion_cfg("OcclusionCulling.cfg");
+	//	mSceneMgr->setWorldGeometry(occlusion_cfg);
 		//createPostproc();
 		OgreIlluminationManager::getSingleton().setBlurShadowMap(true);
